Zen<-ts(read.table("C:/Users/dell/Desktop/ZenReturns.txt",header=T),start=c(1,1),freq=1)
plot(Zen)
library(rugarch)
library(PerformanceAnalytics)
cleansedreturns <- Return.clean(Zen, method = c("none", "boudt", "geltner"), alpha = 0.01)
plot(cleansedreturns)
library(fBasics)
Zen1<-as.vector(cleansedreturns)
library(fitdistrplus)
descdist(Zen1)
jarqueberaTest(cleansedreturns)
library(tseries)
adf.test(cleansedreturns)
#source code for ARCH LM Test
ArchTest <- function (x, lags=12, demean = FALSE) 
{ 
# Capture name of x for documentation in the output  
xName <- deparse(substitute(x)) 
# 
x <- as.vector(x) 
if(demean) x <- scale(x, center = TRUE, scale = FALSE) 
#  
lags <- lags + 1 
mat <- embed(x^2, lags) 
arch.lm <- summary(lm(mat[, 1] ~ mat[, -1])) 
STATISTIC <- arch.lm$r.squared * length(resid(arch.lm)) 
names(STATISTIC) <- "Chi-squared" 
PARAMETER <- lags - 1 
names(PARAMETER) <- "df" 
PVAL <- 1 - pchisq(STATISTIC, df = PARAMETER) 
METHOD <- "ARCH LM-test;  Null hypothesis:  no ARCH effects" 
result <- list(statistic = STATISTIC, parameter = PARAMETER, 
p.value = PVAL, method = METHOD, data.name = xName) 
class(result) <- "htest" 
return(result) 
}

spec1=ugarchspec(variance.model=list(model=c("eGARCH"), garchOrder = c(1, 1)), mean.model = list(armaOrder = c(0, 0), include.mean = FALSE), distribution.model ="norm") 
fit1 = ugarchfit(spec1, cleansedreturns)
fit1
halflife(fit1)
persistence(fit1)
library(parallel) 
cl = makePSOCKcluster(10)
roll8 = ugarchroll(spec1, cleansedreturns, n.start = 2500, refit.every = 100, refit.window = "moving", solver = "hybrid", calculate.VaR = TRUE, VaR.alpha = c(0.01, 0.05), cluster = cl, keep.coef = TRUE)
show(roll8) 
stopCluster(cl)
report(roll8, type = "VaR", VaR.alpha = 0.01, conf.level = 0.99)
report(roll8, type = "VaR", VaR.alpha = 0.05, conf.level = 0.95)


spec2=ugarchspec(variance.model=list(model=c("eGARCH"), garchOrder = c(1, 1)), mean.model = list(armaOrder = c(0, 0), include.mean = FALSE), distribution.model ="ged") 
fit2 = ugarchfit(spec2, cleansedreturns)
fit2
halflife(fit2)
persistence(fit2)
library(parallel) 
cl = makePSOCKcluster(10)
roll9 = ugarchroll(spec2, cleansedreturns, n.start = 2500, refit.every = 100, refit.window = "moving", solver = "hybrid", calculate.VaR = TRUE, VaR.alpha = c(0.01, 0.05), cluster = cl, keep.coef = TRUE)
show(roll9) 
stopCluster(cl)
report(roll9, type = "VaR", VaR.alpha = 0.01, conf.level = 0.99)
report(roll9, type = "VaR", VaR.alpha = 0.05, conf.level = 0.95)

spec3=ugarchspec(variance.model=list(model=c("eGARCH"), garchOrder = c(1, 1)), mean.model = list(armaOrder = c(0, 0), include.mean = FALSE), distribution.model ="std") 
fit3 = ugarchfit(spec3, cleansedreturns)
fit3
halflife(fit3)
persistence(fit3)
library(parallel) 
cl = makePSOCKcluster(10)
roll10 = ugarchroll(spec3, cleansedreturns, n.start = 2500, refit.every = 100, refit.window = "moving", solver = "hybrid", calculate.VaR = TRUE, VaR.alpha = c(0.01, 0.05), cluster = cl, keep.coef = TRUE)
show(roll10) 
stopCluster(cl)
report(roll10, type = "VaR", VaR.alpha = 0.01, conf.level = 0.99)
report(roll10, type = "VaR", VaR.alpha = 0.05, conf.level = 0.95)

spec4=ugarchspec(variance.model=list(model=c("eGARCH"), garchOrder = c(1, 2)), mean.model = list(armaOrder = c(0, 0), include.mean = FALSE), distribution.model ="sstd") 
fit4 = ugarchfit(spec4, cleansedreturns)
fit4
halflife(fit4)
persistence(fit4)
library(parallel) 
cl = makePSOCKcluster(10)
roll11 = ugarchroll(spec4, cleansedreturns, n.start = 2500, refit.every = 100, refit.window = "moving", solver = "hybrid", calculate.VaR = TRUE, VaR.alpha = c(0.01, 0.05), cluster = cl, keep.coef = TRUE)
show(roll11) 
stopCluster(cl)
report(roll11, type = "VaR", VaR.alpha = 0.01, conf.level = 0.99)
report(roll11, type = "VaR", VaR.alpha = 0.05, conf.level = 0.95)

